'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.createInputText = exports.createInputImage = exports.createInputLink = exports.createInputTextarea = exports.createInputFile = exports.createInputRich = exports.createInputSource = exports.getLabel = exports.getAttributes = exports.printInput = exports.raw = exports.sourceOption = exports.sourceAutocomplete = exports.sourceAttr = exports.recursivePrintConfig = exports.recursiveFolder = exports.printConfig = exports.printBlock = exports.listPage = exports.folders = exports.compileAbe = exports.abeImport = exports.abeEngine = exports.form = undefined;

var _handlebars = require('handlebars');

var _handlebars2 = _interopRequireDefault(_handlebars);

var _handlebarsIntl = require('handlebars-intl');

var _handlebarsIntl2 = _interopRequireDefault(_handlebarsIntl);

var _form = require('./form');

var _form2 = _interopRequireDefault(_form);

var _abeEngine = require('./handlebars/abeEngine');

var _abeEngine2 = _interopRequireDefault(_abeEngine);

var _abeImport = require('./handlebars/abeImport');

var _abeImport2 = _interopRequireDefault(_abeImport);

var _compileAbe = require('./handlebars/compileAbe');

var _compileAbe2 = _interopRequireDefault(_compileAbe);

var _folders = require('./handlebars/folders');

var _folders2 = _interopRequireDefault(_folders);

var _listPage = require('./handlebars/listPage');

var _listPage2 = _interopRequireDefault(_listPage);

var _printBlock = require('./handlebars/printBlock');

var _printBlock2 = _interopRequireDefault(_printBlock);

var _printConfig = require('./handlebars/printConfig');

var _printConfig2 = _interopRequireDefault(_printConfig);

var _recursiveFolder = require('./handlebars/recursiveFolder');

var _recursiveFolder2 = _interopRequireDefault(_recursiveFolder);

var _recursivePrintConfig = require('./handlebars/recursivePrintConfig');

var _recursivePrintConfig2 = _interopRequireDefault(_recursivePrintConfig);

var _sourceAttr = require('./handlebars/sourceAttr');

var _sourceAttr2 = _interopRequireDefault(_sourceAttr);

var _sourceAutocomplete = require('./handlebars/sourceAutocomplete');

var _sourceAutocomplete2 = _interopRequireDefault(_sourceAutocomplete);

var _sourceOption = require('./handlebars/sourceOption');

var _sourceOption2 = _interopRequireDefault(_sourceOption);

var _raw = require('./handlebars/raw');

var _raw2 = _interopRequireDefault(_raw);

var _printInput = require('./handlebars/printInput');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Handlebar abe */
_handlebars2.default.registerHelper('abeImport', _abeImport2.default);
_handlebars2.default.registerHelper('abe', _compileAbe2.default);
_handlebars2.default.registerHelper('folders', _folders2.default);
_handlebars2.default.registerHelper('listPage', _listPage2.default);
_handlebars2.default.registerHelper('printBlock', _printBlock2.default);
_handlebars2.default.registerHelper('printConfig', _printConfig2.default);
_handlebars2.default.registerHelper('printInput', _printInput.printInput);
_handlebars2.default.registerHelper('raw', _raw2.default);

_handlebarsIntl2.default.registerWith(_handlebars2.default);

exports.form = _form2.default;
exports.abeEngine = _abeEngine2.default;
exports.abeImport = _abeImport2.default;
exports.compileAbe = _compileAbe2.default;
exports.folders = _folders2.default;
exports.listPage = _listPage2.default;
exports.printBlock = _printBlock2.default;
exports.printConfig = _printConfig2.default;
exports.recursiveFolder = _recursiveFolder2.default;
exports.recursivePrintConfig = _recursivePrintConfig2.default;
exports.sourceAttr = _sourceAttr2.default;
exports.sourceAutocomplete = _sourceAutocomplete2.default;
exports.sourceOption = _sourceOption2.default;
exports.raw = _raw2.default;
exports.printInput = _printInput.printInput;
exports.getAttributes = _printInput.getAttributes;
exports.getLabel = _printInput.getLabel;
exports.createInputSource = _printInput.createInputSource;
exports.createInputRich = _printInput.createInputRich;
exports.createInputFile = _printInput.createInputFile;
exports.createInputTextarea = _printInput.createInputTextarea;
exports.createInputLink = _printInput.createInputLink;
exports.createInputImage = _printInput.createInputImage;
exports.createInputText = _printInput.createInputText;