'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.times = exports.translate = exports.printJson = exports.notEmpty = exports.moduloIf = exports.math = exports.getCurrentuserRole = exports.concat = exports.isAuthorized = exports.setVariable = exports.uppercase = exports.lowercase = exports.truncate = exports.isTrue = exports.ifIn = exports.ifCond = exports.cleanTab = exports.className = exports.attrAbe = exports.insertDebugtoolUtilities = exports.encodeAbeTagAsComment = exports.assets = exports.prepare = exports.template = exports.Handlebars = undefined;

var _handlebars = require('handlebars');

var _handlebars2 = _interopRequireDefault(_handlebars);

var _handlebarsIntl = require('handlebars-intl');

var _handlebarsIntl2 = _interopRequireDefault(_handlebarsIntl);

var _handlebarsHelperSlugify = require('handlebars-helper-slugify');

var _handlebarsHelperSlugify2 = _interopRequireDefault(_handlebarsHelperSlugify);

var _helperMarkdown = require('helper-markdown');

var _helperMarkdown2 = _interopRequireDefault(_helperMarkdown);

var _attrAbe = require('./handlebars/attrAbe');

var _attrAbe2 = _interopRequireDefault(_attrAbe);

var _className = require('./handlebars/className');

var _className2 = _interopRequireDefault(_className);

var _cleanTab = require('./handlebars/cleanTab');

var _cleanTab2 = _interopRequireDefault(_cleanTab);

var _ifCond = require('./handlebars/ifCond');

var _ifCond2 = _interopRequireDefault(_ifCond);

var _ifIn = require('./handlebars/ifIn');

var _ifIn2 = _interopRequireDefault(_ifIn);

var _isTrue = require('./handlebars/isTrue');

var _isTrue2 = _interopRequireDefault(_isTrue);

var _math = require('./handlebars/math');

var _math2 = _interopRequireDefault(_math);

var _moduloIf = require('./handlebars/moduloIf');

var _moduloIf2 = _interopRequireDefault(_moduloIf);

var _notEmpty = require('./handlebars/notEmpty');

var _notEmpty2 = _interopRequireDefault(_notEmpty);

var _printJson = require('./handlebars/printJson');

var _printJson2 = _interopRequireDefault(_printJson);

var _translate = require('./handlebars/translate');

var _translate2 = _interopRequireDefault(_translate);

var _times = require('./handlebars/times');

var _times2 = _interopRequireDefault(_times);

var _truncate = require('./handlebars/truncate');

var _truncate2 = _interopRequireDefault(_truncate);

var _lowercase = require('./handlebars/lowercase');

var _lowercase2 = _interopRequireDefault(_lowercase);

var _uppercase = require('./handlebars/uppercase');

var _uppercase2 = _interopRequireDefault(_uppercase);

var _setVariable = require('./handlebars/setVariable');

var _setVariable2 = _interopRequireDefault(_setVariable);

var _isAuthorized = require('./handlebars/isAuthorized');

var _isAuthorized2 = _interopRequireDefault(_isAuthorized);

var _concat = require('./handlebars/concat');

var _concat2 = _interopRequireDefault(_concat);

var _getCurrentuserRole = require('./handlebars/getCurrentuserRole');

var _getCurrentuserRole2 = _interopRequireDefault(_getCurrentuserRole);

var _template = require('./template');

var template = _interopRequireWildcard(_template);

var _prepare = require('./prepare');

var prepare = _interopRequireWildcard(_prepare);

var _assets = require('./assets');

var assets = _interopRequireWildcard(_assets);

var _encodeAbeTagAsComment = require('./encodeAbeTagAsComment');

var _encodeAbeTagAsComment2 = _interopRequireDefault(_encodeAbeTagAsComment);

var _insertDebugtoolUtilities = require('./insertDebugtoolUtilities');

var _insertDebugtoolUtilities2 = _interopRequireDefault(_insertDebugtoolUtilities);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Register utilities */


/* Handlebar utilities */
require('handlebars-helpers')();
_handlebars2.default.registerHelper('markdown', (0, _helperMarkdown2.default)());
_handlebars2.default.registerHelper('attrAbe', _attrAbe2.default);
_handlebars2.default.registerHelper('className', _className2.default);
_handlebars2.default.registerHelper('cleanTab', _cleanTab2.default);
_handlebars2.default.registerHelper('slugify', (0, _handlebarsHelperSlugify2.default)({ Handlebars: _handlebars2.default }).slugify);
_handlebars2.default.registerHelper('ifCond', _ifCond2.default);
_handlebars2.default.registerHelper('ifIn', _ifIn2.default);
_handlebars2.default.registerHelper('isTrue', _isTrue2.default);
_handlebars2.default.registerHelper('math', _math2.default);
_handlebars2.default.registerHelper('moduloIf', _moduloIf2.default);
_handlebars2.default.registerHelper('notEmpty', _notEmpty2.default);
_handlebars2.default.registerHelper('printJson', _printJson2.default);
_handlebars2.default.registerHelper('i18nAbe', _translate2.default);
_handlebars2.default.registerHelper('times', _times2.default);
_handlebars2.default.registerHelper('truncate', _truncate2.default);
_handlebars2.default.registerHelper('lowercase', _lowercase2.default);
_handlebars2.default.registerHelper('uppercase', _uppercase2.default);
_handlebars2.default.registerHelper('setVariable', _setVariable2.default);
_handlebars2.default.registerHelper('isAuthorized', _isAuthorized2.default);
_handlebars2.default.registerHelper('concat', _concat2.default);
_handlebars2.default.registerHelper('getCurrentuserRole', _getCurrentuserRole2.default);

_handlebarsIntl2.default.registerWith(_handlebars2.default);

exports.Handlebars = _handlebars2.default;
exports.template = template;
exports.prepare = prepare;
exports.assets = assets;
exports.encodeAbeTagAsComment = _encodeAbeTagAsComment2.default;
exports.insertDebugtoolUtilities = _insertDebugtoolUtilities2.default;
exports.attrAbe = _attrAbe2.default;
exports.className = _className2.default;
exports.cleanTab = _cleanTab2.default;
exports.ifCond = _ifCond2.default;
exports.ifIn = _ifIn2.default;
exports.isTrue = _isTrue2.default;
exports.truncate = _truncate2.default;
exports.lowercase = _lowercase2.default;
exports.uppercase = _uppercase2.default;
exports.setVariable = _setVariable2.default;
exports.isAuthorized = _isAuthorized2.default;
exports.concat = _concat2.default;
exports.getCurrentuserRole = _getCurrentuserRole2.default;
exports.math = _math2.default;
exports.moduloIf = _moduloIf2.default;
exports.notEmpty = _notEmpty2.default;
exports.printJson = _printJson2.default;
exports.translate = _translate2.default;
exports.times = _times2.default;